        USE ERRORS

	INTEGER, DIMENSION(:), ALLOCATABLE :: ISPIN
	REAL   (KIND=8), DIMENSION(:), ALLOCATABLE ::  SPSP, OBS, OBS1
	REAL   (KIND=8), DIMENSION(:,:,:) :: RATIO(-1:1,-1:1,-1:1)
	
	
	OPEN (UNIT=20, FILE='param_a',  STATUS= 'UNKNOWN')
	OPEN (UNIT=61, FILE='res.dat',  STATUS= 'UNKNOWN')
	OPEN (UNIT=60, FILE='auto.dat', STATUS= 'UNKNOWN')
	READ(20,*) L,BETA, XJ, NSWEEP, NBINM, NWARM

        ALLOCATE ( ISPIN(L)  )
        ALLOCATE ( SPSP(L/2) )
        ALLOCATE ( OBS (NSWEEP) )

!       Random initial configuration.
	ISEED = 859851
	DO I = 1,L
	   ISPIN(I) = 1
	   IF (RANF(ISEED).LT.0.5) ISPIN(I) = -1
	ENDDO
	
	DO IS  = -1,1,2
	DO ISP = -1,1,2
	DO ISM = -1,1,2
	   TMP = FLOAT(IS * ( ISP + ISM ) )
	   X = EXP( + BETA*XJ*TMP )/EXP(-BETA*XJ*TMP)
	   RATIO(IS,ISM,ISP) = X/(1.0 + X)
	ENDDO
	ENDDO
	ENDDO

	  DO NS = 1, NSWEEP + NWARM
!	     Upgrade One sweep.
	     DO NTH1 = 1,2
	      NF  = INT( RANF(ISEED) + 0.5)
!             NF = 0,1
	      DO NTH = 1,L/2
	        I  = NPBC(NF + NTH*2,L)
	        IP = NPBC(I+1,L)
	        IM = NPBC(I-1,L)
	        IS = ISPIN(I)
	        ISP= ISPIN(IP)
	        ISM =ISPIN(IM)
	        IF (RATIO(IS,ISM,ISP).GT.RANF(ISEED)) &
                     &     ISPIN(I) = -ISPIN(I)
	      ENDDO
	     ENDDO
!	     Calculate Observable.
             IF (NS.GT.NWARM) THEN
                DO NR = 1,L/2
                   SPSP(NR) = 0.D0
                   DO I =  1,L
                      INR = NPBC(I+NR,L) 
                      SPSP(NR) = SPSP(NR) + FLOAT(ISPIN(I)*ISPIN(INR))
                   ENDDO
                ENDDO
                XNORM = 1.0/FLOAT(L)
                DO NR = 1,L/2
                   SPSP(NR) = SPSP(NR)*XNORM
                ENDDO
                OBS(NS-WARM) = SPSP(L/2)
             ENDIF
	  ENDDO

	  DO NTAU = 0,NBINM
!            Compute autocorrelation time.             
	     X1 = 0.0
	     X2 = 0.0
	     X3 = 0.0
	     DO NT = 1,NSWEEP - NTAU
	        X1 = X1 + OBS(NT)*OBS(NT + NTAU) 
	        X2 = X2 + OBS(NT)*OBS(NT)
	        X3 = X3 + OBS(NT)
	     ENDDO
	     X1 = X1 / FLOAT(NSWEEP - NTAU)
	     X2 = X2 / FLOAT(NSWEEP - NTAU)
	     X3 = X3 / FLOAT(NSWEEP - NTAU)

	     AUTOC = ( X1 - X3**2)/(X2 - X3**2)

!            Binning, mean and error. Bin size is NTAU.

	     WRITE(60,2002) NTAU, AUTOC 

             IF (NTAU.GE.1) THEN
                NP = NSWEEP/NTAU
                ALLOCATE(OBS1(NP))
                NC = 0
                DO N = 1,NP
                   X = 0.D0
                   DO N1 = 1,NTAU
                      NC = NC + 1
                      X = X + OBS(NC)
                   ENDDO
                   OBS1(N) = X/DBLE(NTAU)
                ENDDO
                CALL ERRCALC(OBS1,XM,XERR)
                WRITE(61,2003) NTAU, XM, XERR
                DEALLOCATE(OBS1)
             ENDIF
	  ENDDO
	
2002	FORMAT(I4,2x,F16.8)
2003	FORMAT(I4,2x,F16.8,2x,F16.8)

	
2001	FORMAT(I4,2x,F16.8,2x,F16.8)

        DEALLOCATE ( SPSP )
        DEALLOCATE ( OBS  )

	STOP
        END
!=======================================================================
        INTEGER FUNCTION NPBC(NR,L)

        NPBC = NR
        IF (NR.GT.L) NPBC = NR - L
        IF (NR.LT.1) NPBC = NR + L

        RETURN
        END

!=======================================================================
      real*8 function ranf(iseed)
!     a = 7^5, m = 2^31 -1 
!     m = a*q + r
      parameter( ia = 16807,  im = 2147483647)
      parameter( iq = 127773, ir = 2836)
      
      integer k

      k = iseed/iq
      iseed = ia*(iseed - k*iq) -ir*k
      if (iseed .lt.0) iseed = iseed + im
      ranf = dble(iseed)/dble(im)

      return
      end
